package com.gic.haoban.manage.service.service;

import java.util.List;

import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.service.entity.TabHaobanDepartment;
import com.github.pagehelper.Page;

public interface DepartmentService {

	List<TabHaobanDepartment> listByParentId(String parentId);

	TabHaobanDepartment selectById(String departmentId);

	String add(DepartmentDTO department);

	void edit(DepartmentDTO department);

	void del(String departmentId);

	TabHaobanDepartment selectByRelatedId(String relatedId);

	TabHaobanDepartment getByWxId(String wxDepartmentId, String wxEnterpriseId);

	void recycle(String departmentId);

	Page<TabHaobanDepartment> pageDepartmentByParams(String wxEnterpriseId, String keyword, Integer storeFlag, Integer recycleFlag);

	void repairRecycle(TabHaobanDepartment tab);

	DepartmentDTO getRootByEnterpriseId(String wxEnterpriseId);

	DepartmentDTO getByRelatedId(String storeId);

	Page<TabHaobanDepartment> pageByParentId(String parentId, String keyword);

	List<TabHaobanDepartment> listByChainId(String chainId, String wxEnterpriseId);

	Integer departmentRecycleCount(String wxEnterpriseId);

	int countSyncDepartmentByEnterpriseId(String enterpriseId);

	int countByDepartment(String departmentId);

	DepartmentDTO getByRelatedIdNotInRecycle(String relatedId);

	List<DepartmentDTO> listByIds(List<String> departmentIds);

	/**
	 * 获取暂存区
	 *
	 * @param wxEnterpriseId
	 * @return
	 */
	DepartmentDTO getTempFlagDepartment(String wxEnterpriseId);

	Integer totalStoreCountByEnterpriseId(String wxEnterpriseId);

}
