package com.gic.haoban.manage.web.controller;

import cn.hutool.core.collection.CollectionUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.dict.api.dto.*;
import com.gic.dict.api.dto.DictDTO;
import com.gic.dict.api.service.ManagerDictService;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.dto.StorePhotoDTO;
import com.gic.haoban.app.customer.dto.StaffOpenRelatedDTO;
import com.gic.haoban.app.customer.service.api.service.StaffMemberRelationApiService;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.contacts.manage.api.service.StoreService;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.service.ClerkMainStoreRelatedApiService;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.api.service.StaffDepartmentRelatedApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseRelatedApiService;
import com.gic.haoban.manage.web.config.Config;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.qo.GetUserByMemberCodeQo;
import com.gic.haoban.manage.web.qo.MemberLoginQo;
import com.gic.haoban.manage.web.vo.AppStaffVo;
import com.gic.haoban.manage.web.vo.InfoVo;
import com.gic.haoban.manage.web.vo.StoreVO;
import com.gic.wechat.api.dto.qywx.UserDTO;
import com.gic.wechat.api.service.qywx.QywxCorpApiService;
import com.gic.wechat.api.service.qywx.QywxUserApiService;

import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;
import java.util.stream.Collectors;

@RestController
public class InfoController extends WebBaseController{
//	public static final  String siteId = "ww2c34dc56739bb105";

	@Autowired
	private QywxCorpApiService qywxCorpApiService;
	@Autowired
	private StaffApiService staffApiService;
	@Autowired
	private WxEnterpriseApiService wxEnterpriseApiService;

    @Autowired
    private WxEnterpriseRelatedApiService wxEnterpriseRelatedApiService;

    @Autowired
    private QywxUserApiService qywxUserApiService;

    @Autowired
    private DepartmentApiService departmentApiService;

    @Autowired
    private com.gic.enterprise.api.service.StoreService storeService;

    @Autowired
    private MemberUnionidRelatedApiService memberUnionidRelatedApiService;
    @Autowired
    private ClerkService clerkService;
    
	@Autowired
	private ClerkMainStoreRelatedApiService clerkMainStoreRelatedApiService;
	@Autowired
	private StaffDepartmentRelatedApiService staffDepartmentRelatedApiService;

	@Autowired
	private ManagerDictService managerDictService;

	@Autowired
	private StaffMemberRelationApiService staffMemberRelationApiService;
	
    private static Logger logger= LoggerFactory.getLogger(InfoController.class);

	@Autowired
	private Config config;

	@RequestMapping("get-info-by-code")
    public HaobanResponse getInfoByCode(String code) {
        String userDTOJson = qywxCorpApiService.getCodeSession(config.getWxSuiteid(),code);
        logger.info("userDTOJson=============>{}",userDTOJson);
        UserDTO user = JSON.parseObject(userDTOJson, UserDTO.class);
        if(user == null) {

            return resultResponse(HaoBanErrCode.ERR_6);
        }
        String userId = user.getUserid();
        String corpId = user.getCorpid();
        WxEnterpriseDTO enterprise = wxEnterpriseApiService.getEnterpriseBycorpId(corpId);
        StaffDTO loginStaff = null;
        if(enterprise != null){
            loginStaff = staffApiService.selectByUserIdAndEnterpriseId(userId,enterprise.getWxEnterpriseId());
        }
        if(loginStaff == null){
            if(enterprise != null){
                staffApiService.wxGetAdd(userId,enterprise.getWxEnterpriseId());
                loginStaff = staffApiService.selectByUserIdAndEnterpriseId(userId,enterprise.getWxEnterpriseId());
            }
        }
        if(loginStaff == null){
            return resultResponse(HaoBanErrCode.ERR_600001);
        }
        if (StringUtils.isNotBlank(loginStaff.getPhoneNumber())) {
            DictDTO loginPhoneNum = managerDictService.getSMSDict("app_login_phone_num", loginStaff.getPhoneNumber());
            logger.info("伪登录：{}",loginStaff.getPhoneNumber(), JSONObject.toJSONString(loginPhoneNum));
            if (null != loginPhoneNum) {
                String midPhone = loginPhoneNum.getDictValue();
                StaffDTO staffDTO = staffApiService.selectByNationcodeAndPhoneNumber(enterprise.getWxEnterpriseId(), "86", midPhone);
                if (null !=staffDTO) {
                    loginStaff=staffDTO;
                }
            }

        }

        String wxEnterpriseId = loginStaff.getWxEnterpriseId();
        WxEnterpriseDTO wxEnterpriseDTO = wxEnterpriseApiService.getOne(wxEnterpriseId);
        String accesstoken = qywxCorpApiService.getCorpAccessToken(wxEnterpriseDTO.getCorpid(), config.getWxSuiteid());
        InfoVo infoVo = new InfoVo();
        infoVo.setAccessToken(accesstoken);
        infoVo.setStaffId(loginStaff.getStaffId());
        infoVo.setWxEnterpriseId(wxEnterpriseId);
        infoVo.setStaffName(loginStaff.getStaffName());
        infoVo.setPhoneNumber(loginStaff.getPhoneNumber());
        infoVo.setNationcode(loginStaff.getNationCode());
        infoVo.setWxUserId(loginStaff.getWxUserId());
        return resultResponse(HaoBanErrCode.ERR_1,infoVo);

    }

    @RequestMapping("get-user-by-member-code")
    public HaobanResponse getInfoByMemberCode(GetUserByMemberCodeQo qo) {
        EnterpriseDetailDTO enterpriseDetailDTO = wxEnterpriseRelatedApiService.getByEnterpriseId(qo.getGicEnterpriseId());
        if (enterpriseDetailDTO == null) {
            logger.info("改企业没有关系好办:{}", qo.getGicEnterpriseId());
            return resultResponse(HaoBanErrCode.ERR_500001);
        }

        WxEnterpriseDTO enterpriseDTO = wxEnterpriseApiService.getOne(enterpriseDetailDTO.getWxEnterpriseId());
        if (enterpriseDetailDTO == null) {
            logger.info("改企业不存在:{}", qo.getGicEnterpriseId());
            return resultResponse(HaoBanErrCode.ERR_400002);
        }
        MemberLoginQo user = new MemberLoginQo();
        if (StringUtils.isBlank(qo.getUserId())) {

            String userDTOJson = qywxUserApiService.getUserByCode(enterpriseDTO.getCorpid(), enterpriseDTO.getMemberSecret(), qo.getCode());
            logger.info("会员微信登录信息=============>{}", userDTOJson);
            user = JSON.parseObject(userDTOJson, MemberLoginQo.class);
            if (user == null) {
                return resultResponse(HaoBanErrCode.ERR_6);
            }
        } else {
            user.setUserId(qo.getUserId());
        }
        StaffDTO staffDTO = staffApiService.selectByUserIdAndEnterpriseId(user.getUserId(), enterpriseDTO.getWxEnterpriseId());
        if (staffDTO == null) {
            logger.info("成员不存在");
            return resultResponse(HaoBanErrCode.ERR_6);
        }
        //保存关联关系
        StaffOpenRelatedDTO relatedDTO = new StaffOpenRelatedDTO();
        relatedDTO.setMemberId(qo.getMemberId());
        relatedDTO.setOpenId(qo.getOpenid());
        relatedDTO.setStaffId(staffDTO.getStaffId());
        relatedDTO.setWxEnterpriseId(enterpriseDTO.getWxEnterpriseId());
        relatedDTO.setGicEnterpriseId(enterpriseDetailDTO.getEnterpriseId());
        staffMemberRelationApiService.bindMemberAndStaff(relatedDTO);

        ServiceResponse<List<DepartmentDTO>> response = departmentApiService.listStoreListByStaffId(staffDTO.getStaffId());
        List<DepartmentDTO> result = response.getResult();
        List<StoreVO> retList = new ArrayList<>();
        if (response.getCode() == 1 && CollectionUtils.isNotEmpty(result)) {
            result.stream().forEach(dto -> {
                StoreVO VO = new StoreVO();
                VO.setDepartmentId(dto.getDepartmentId());
                VO.setStoreId(dto.getRelatedId());//为空，则无该值
                VO.setStoreName(dto.getDepartmentName());
                VO.setWxEnterpriseId(dto.getWxEnterpriseId());
                VO.setStoreImg("");//先置空
                if (org.apache.commons.lang.StringUtils.isNotBlank(dto.getRelatedId())) {
                    StoreDTO storeDTO = storeService.getStore(dto.getRelatedId());
                    if (storeDTO != null) {
                        VO.setEnterpriseId(storeDTO.getEnterpriseId());
                        VO.setStoreImg(storeDTO.getImageUrl());//先置空
                    }
                }
                VO.setCreateTime(dto.getCreateTime());
                retList.add(VO);
            });
            
            //塞clerkCOde等基本信息
    		List<StaffDepartmentRelatedDTO> relateList = staffDepartmentRelatedApiService.listByStaffId(staffDTO.getStaffId());
			Map<String,StaffDepartmentRelatedDTO> map = com.gic.commons.util.CollectionUtil.toMap(relateList, "departmentId");
			for(StoreVO VO : retList){
				StaffDepartmentRelatedDTO staffDepartmentRelatedDTO = map.get(VO.getDepartmentId());
				if(staffDepartmentRelatedDTO != null){
					String clerkCode = staffDepartmentRelatedDTO.getClerkCode();
					VO.setBindFlag(StringUtils.isEmpty(clerkCode)?0:1);
					VO.setClerkCode(clerkCode);
					VO.setStaffDepartmentRelatedId(staffDepartmentRelatedDTO.getStaffDepartmentRelatedId());
					VO.setStaffId(staffDTO.getStaffId());
					ClerkDTO clerkDTO  = clerkService.getClerkByClerkCode(VO.getEnterpriseId(), clerkCode);
					VO.setClerkId(clerkDTO == null?"":clerkDTO.getClerkId());
				}else{
					VO.setBindFlag(0);
				}
			}
            
            
            //塞门店店长标志
    		ClerkMainStoreRelatedDTO mainStore = clerkMainStoreRelatedApiService.getWxEnterpriseIdAndStaffId(enterpriseDTO.getWxEnterpriseId(),staffDTO.getStaffId());
            for(StoreVO VO : retList){
    			//查gic门店
    			StoreDTO storeDTO = storeService.getStore(VO.getStoreId());
    			List<StorePhotoDTO> imgList = storeService.getStoreImages(VO.getStoreId());
    			EnterpriseDetailDTO detail = wxEnterpriseRelatedApiService.getByEnterpriseId(storeDTO.getEnterpriseId());
    			VO.setWxEnterpriseRelatedId(detail.getWxEnterpriseRelatedId());
    			//已经绑定的门店
    			if(VO.getBindFlag()==1){
    				String clerkCode = VO.getClerkCode();
    				if(StringUtils.isEmpty(clerkCode)){
    					VO.setClerkType(0);
    				}else{
    					if(storeDTO != null){
    						//查gic门店店长
    						ClerkDTO clerkDTO = clerkService.getClerkByClerkId(storeDTO.getClerkId());
    						if(clerkDTO != null){
    							//code相同，则置为1
    							if(clerkCode.equals(clerkDTO.getClerkCode())){
    								VO.setClerkType(1);
    							}
    						}
    					}
    				}
    			}
    			if(CollectionUtil.isNotEmpty(imgList)){
    				VO.setStoreImg(imgList.get(0).getQcloudImageUrl());;
    			}
    			
    			if(mainStore != null && mainStore.getStoreId().equals(VO.getStoreId())){
    				VO.setMainStoreFlag(1);
    			}else{
    				VO.setMainStoreFlag(0);
    			}
    		}
            user.setStoreList(retList);
        }
        return resultResponse(HaoBanErrCode.ERR_1, user);

    }
	
	@RequestMapping("save-user-login-log")
	public HaobanResponse saveUserLoginLog(UserLoginLogDTO userLoginLogDTO) {
		staffApiService.insertUserLoginLog(userLoginLogDTO);
		return resultResponse(HaoBanErrCode.ERR_1);
		
	}
	
	@RequestMapping("get-member-store")
	public HaobanResponse getMemberStore(String externalUserid,String wxUserId) {
        if (StringUtils.isAnyBlank(externalUserid,wxUserId)) {
            return resultResponse(HaoBanErrCode.ERR_2);
        }
        List<MemberStoreDTO> result =  memberUnionidRelatedApiService.listByExTernalUseridAndWxUserId(externalUserid, wxUserId);
        return resultResponse(HaoBanErrCode.ERR_1,result);
	}
	
	@RequestMapping("get-staff-info")
	public HaobanResponse getStaffInfo(String phoneNumber) {
        if (StringUtils.isBlank(phoneNumber)) {
            return resultResponse(HaoBanErrCode.ERR_2);
        }
        List<StaffDTO> list = staffApiService.listByPhoneNumber(phoneNumber);
        if(CollectionUtil.isNotEmpty(list)){
        	List<AppStaffVo> staffs = EntityUtil.changeEntityListByJSON(AppStaffVo.class, list);
        	Set<String> wxEnterpriseIds = list.stream().map(s->s.getWxEnterpriseId()).collect(Collectors.toSet());
        	List<YwWxEnterpriseDTO> enterprises = wxEnterpriseApiService.listByIds(wxEnterpriseIds);
        	Map<String,YwWxEnterpriseDTO> map = com.gic.commons.util.CollectionUtil.toMap(enterprises, "wxEnterpriseId");
        	for(AppStaffVo vo:staffs){
        		String wxEnterpriseId = vo.getWxEnterpriseId();
        		String corpName = map.get(wxEnterpriseId) == null?"":map.get(wxEnterpriseId).getCorpName();
        		vo.setWxEnterpriseName(corpName);
        	}
    		return resultResponse(HaoBanErrCode.ERR_1,staffs);
        }
		return resultResponse(HaoBanErrCode.ERR_1,new ArrayList<>());
		
	}
}
